local Q 
RANDOM_WIDTH_THAT_WONT_BE_OVER_WRITTEN = {}
local DQuest = Dominos:NewModule('QuestLog')
local Quest

function DQuest:Load()
	self.frame = Quest:New()
	self.frame:SetFrameStrata('LOW')
end

function DQuest:Unload()
	self.frame:Free()
end

Quest = Dominos:CreateClass('Frame', Dominos.Frame)

function Quest:New()
	local f = self.super.New(self, 'QuestTracker')
	f:OnLoad()
	f:Layout()
	return f
end

function Quest:GetDefaults()
	return {
		scale = 1,
		point = 'RIGHT',
		x = 0,
		y= 0,
		width = 80,
		height = 300,
		padding = 0,
	}
end

local HEIGHT = 1000
function Quest:OnLoad()
	self.WFC = CreateFrame("Frame", "DominosQuestFrame", self)
	self.WFC.scrollframe = CreateFrame("ScrollFrame", nil, self.WFC) 

	self.WFC.scrollframe.scroll = CreateFrame("Slider", "DominosQuestFrameScrollBar", self.WFC.scrollframe, "OptionsSliderTemplate")
	self.WFC.scrollframe.scroll:SetMinMaxValues(1, (75/131) * HEIGHT)
	_G[self.WFC.scrollframe.scroll:GetName() .. 'High']:SetText("")
	_G[self.WFC.scrollframe.scroll:GetName() .. 'Low']:SetText("")
	self.WFC.scrollframe.scroll:SetOrientation("VERTICAL")
	self.WFC.scrollframe.scroll:SetValueStep(5) 
	self.WFC.scrollframe.scroll.scrollStep = 1 
	self.WFC.scrollframe.scroll:SetWidth(15) 

	self.WFC.scrollframe.scroll:SetScript("OnValueChanged", function (self, value) 
		self:GetParent():SetVerticalScroll(value) 
	end)

	Quest:EnableScroll(self)
	self.WFC:SetScript("OnUpdate", function(self) self:EnableMouse(false) end)
	self.scrollchild = CreateFrame("Frame", "scrollchild", self.WFC.scrollframe)
	self.WFC.scrollframe:SetScrollChild(self.scrollchild)
	self.scrollchild:SetHeight(HEIGHT)
	self.WFC:RegisterEvent("PLAYER_ENTERING_WORLD");
	self.WFC:RegisterEvent("QUEST_LOG_UPDATE");
	self.WFC:SetScript("OnEvent", function()
		--This event script keeps the WatchFrame 
		--from reseting to it's default location.
		--Also keeps the default WatchFrame code 
		--from bugging out on login.
		Quest:SetUpContainer(self)
	end)
	Quest:Swap(self)
end


--[[Layout]]--
function Quest:Layout()
	self.WFC:SetParent(self)
	local pad = self.sets.padding - 4
	local width = (self.sets.width) + self.sets.padding
	local height = (self.sets.height) + pad

	self:SetSize( width, height)

	--We Can't use "SetSize" for this frame as 
	--it cause the default WatchFrame code to 
	--bug out... I'm not sure why though.
	self.WFC:SetPoint("TOPLEFT", pad/2, -pad/2)
	self.WFC:SetPoint("BOTTOMRIGHT", -pad/2, pad/2)
end

function Quest:EnableScroll(self)
	local function scrollbar_OnScroll(x, arg1)
		local step = (self.WFC.scrollframe.scroll:GetValueStep() * arg1)
		local value = self.WFC.scrollframe.scroll:GetValue()
		local minVal, maxVal = self.WFC.scrollframe.scroll:GetMinMaxValues()
		if step > 0 then
			self.WFC.scrollframe.scroll:SetValue(min(value-step, maxVal))
		else
			self.WFC.scrollframe.scroll:SetValue(max(value-step, minVal))
		end
	end


	if not self.sets.disablescroll then
		self.WFC.scrollframe.scroll:Show()
		self.WFC.scrollframe:SetScript('OnMouseWheel', scrollbar_OnScroll)
		self.WFC.scrollframe.scroll:SetScript('OnMouseWheel', scrollbar_OnScroll)
	else
		self.WFC.scrollframe.scroll:SetValue(1)
		self.WFC.scrollframe.scroll:Hide()
		self.WFC.scrollframe:SetScript('OnMouseWheel', nil)
		self.WFC.scrollframe.scroll:SetScript('OnMouseWheel', nil)
	end
end

function Quest:ToggleScroll(enable)
	self.sets.disablescroll = enable or nil
	Quest:EnableScroll(self)
	Quest:Swap(self)
end

function Quest:Swap(self)

	local SF = self.WFC.scrollframe
	SF.scroll = self.WFC.scrollframe.scroll
	local WFCEB = WatchFrameCollapseExpandButton
	self.WFC.scrollframe:ClearAllPoints()
	self.WFC.scrollframe.scroll:ClearAllPoints()
	WFCEB:ClearAllPoints()
	WFCEB:SetParent(self.WFC)
	local r
	if self.sets.disablescroll then
		r = 0
	else
		r = 17
	end
	if self.sets.swapsides then
		SF:SetPoint("BOTTOMLEFT", r, 5) 
		SF:SetPoint("TOPRIGHT", 0, -18)
		SF.scroll:SetPoint("BOTTOMRIGHT", SF, "BOTTOMLEFT", 0, -3)
		SF.scroll:SetPoint("TOPRIGHT", SF, "TOPLEFT",  0, 3)
		WFCEB:SetPoint("TOPLEFT", 2, 0)
		WFCEB.p = {"LEFT", "RIGHT", 0, 0,}
	else
		SF:SetPoint("BOTTOMRIGHT", -r, 5) 
		SF:SetPoint("TOPLEFT", 0, -18)
		SF.scroll:SetPoint("BOTTOMLEFT", SF, "BOTTOMRIGHT",  0, -3)
		SF.scroll:SetPoint("TOPLEFT", SF, "TOPRIGHT",  0, 3)
		WFCEB:SetPoint("TOPRIGHT", -2, 0)
		WFCEB.p = {"RIGHT", "LEFT", 0, 0,}
	end
	
	SF:SetScript("OnSizeChanged", function(_, w)
		local w = w - 14
		self.scrollchild:SetWidth(w)
		WATCHFRAME_EXPANDEDWIDTH = self.scrollchild:GetWidth()-13
		WATCHFRAME_MAXLINEWIDTH = WATCHFRAME_EXPANDEDWIDTH - 3;
		RANDOM_WIDTH_THAT_WONT_BE_OVER_WRITTEN = self.scrollchild:GetWidth()
		WatchFrame:SetWidth(self.scrollchild:GetWidth()-3);
		WatchFrame_Update();
	end)
end

function Quest:ToggleSides(enable)
	self.sets.swapsides = enable or nil
	Quest:Swap(self)
end


function Quest:SetUpContainer(self)
	self.WFC.scrollframe.scroll:SetValue(1)
	WatchFrame_Update()
	WatchFrame:ClearAllPoints()
	WatchFrame:SetHeight(HEIGHT)
	WatchFrame:SetMovable(true)
	WatchFrame:SetUserPlaced(true)

	WatchFrame:SetParent(self.scrollchild)
	WatchFrame:SetClampedToScreen(false)
	WatchFrame:SetPoint("TOPLEFT", 24 , 0)

	WatchFrameCollapseExpandButton:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self)
		GameTooltip:AddLine("Dominos Minimap",1,1,1)
		if WatchFrame.collapsed then
			GameTooltip:AddLine("Left-click to expand the objectives tracker.")
		else
			GameTooltip:AddLine("Left-click to minimize the objectives tracker.")
		end
		GameTooltip:AddLine("Right-click to toggle the quest log.")
		GameTooltip:AddLine("Shift-click to toggle the achievements window.")
		GameTooltip:Show()
	end)

	WatchFrameHeader:ClearAllPoints()
	WatchFrameHeader:SetParent(self.WFC)
	WatchFrameHeader:SetPoint("TOPLEFT", 23 , 0) 

	WatchFrameCollapseExpandButton:Show()
	--Had to increase the frame level so 
	--the button would stay on top of the scroll bar
	WatchFrameCollapseExpandButton:SetFrameLevel(self.WFC.scrollframe.scroll:GetFrameLevel()+3) 
	WatchFrameCollapseExpandButton.Hide = function() end
	WatchFrameCollapseExpandButton.Disable = function() end
	WatchFrameCollapseExpandButton:RegisterForClicks("AnyDown")
	WatchFrameCollapseExpandButton:SetScript("OnLeave", function() GameTooltip:Hide() end)
	local WFCEB = WatchFrameCollapseExpandButton
	local SF = self.WFC.scrollframe.scroll
	WatchFrameCollapseExpandButton:SetScript("OnClick", function(_,btn)
		if IsShiftKeyDown() then
			ToggleAchievementFrame()
		elseif btn == "RightButton" then
			ToggleFrame(QuestLogFrame)
		else
			WatchFrame_CollapseExpandButton_OnClick()
			if (  WatchFrame.collapsed ) then
				WatchFrameHeader:ClearAllPoints()
				WatchFrameHeader:SetPoint(WFCEB.p[1], WFCEB, WFCEB.p[2],WFCEB.p[3], WFCEB.p[4])
			else
				WatchFrameHeader:ClearAllPoints()
				WatchFrameHeader:SetPoint("TOPLEFT", self.WFC, "TOPLEFT", 23, 0)
			end
			if not self.sets.disablescroll then
				if SF:IsVisible() then
					SF:Hide()
				else
					SF:Show()
				end
			end
		end
	end)

	WatchFrameHeader:Show()
	WatchFrameHeader:SetPoint("TOPLEFT", self.WFC, "TOPLEFT", 23, 0)
	WatchFrameHeader.Hide = function() WatchFrameTitle:SetText(OBJECTIVES_TRACKER_LABEL.." (0)")  end
	WatchFrameHeader:SetFrameLevel(WatchFrameHeader:GetParent():GetFrameLevel()+2)
	WatchFrameTitle:ClearAllPoints()
	WatchFrameTitle:SetPoint("CENTER")
	WatchFrameTitle.Hide = function() end
	WatchFrameTitle:SetParent(WatchFrameHeader)
	WatchFrameLines:ClearAllPoints()
	WatchFrameLines:SetPoint("TOPLEFT", WatchFrame, "TOPLEFT", 0, 0)
	WatchFrameLines:SetPoint("BOTTOMRIGHT", WatchFrame, "BOTTOMRIGHT", -24, 12)
end

--[[Layout Panel--]]
local function CreateWidthSlider(p)
	local s = p:NewSlider("Width", 1, 160, 1)
	s.OnShow = function(self)
		self:SetValue(self:GetParent().owner.sets.width - 134)
	end
	s.UpdateValue = function(self, value)
		local f = self:GetParent().owner
		f.sets.width = value + 134
		f:Layout()
	end
end

local function CreateHeightSlider(p)
	local s = p:NewSlider("Height", 50, GetScreenHeight(), 1, OnShow)
	s.OnShow = function(self)
		self:SetValue(self:GetParent().owner.sets.height)
	end
	s.UpdateValue = function(self, value)
		local f = self:GetParent().owner
		f.sets.height = value
		f:Layout()
	end
end

local function CreatePaddingSlider(p)

	local s = p:NewSlider("Padding", -10, 90, 1, OnShow)
	s.OnShow = function(self)
		self:SetValue(self:GetParent().owner.sets.padding)
	end
	s.UpdateValue = function(self, value)
		local f = self:GetParent().owner
		f.sets.padding = value

		f:Layout()
	end
end

local function AddLayoutPanel(menu)
	local p = menu:NewPanel(LibStub('AceLocale-3.0'):GetLocale('Dominos-Config').Layout)
	p:NewOpacitySlider()
	p:NewFadeSlider()
	CreateWidthSlider(p)
	CreateHeightSlider(p)
	CreatePaddingSlider(p)
	p:NewScaleSlider()

	local SwapSides = p:NewCheckButton("Swap sides")
	SwapSides:SetScript('OnClick', function(self) self:GetParent().owner:ToggleSides(self:GetChecked()) end)
	SwapSides:SetScript('OnShow', function(self) self:SetChecked(self:GetParent().owner.sets.swapsides) end)
	
	local ToggleScroll = p:NewCheckButton("Disable ScrollBar")
	ToggleScroll:SetScript('OnClick', function(self) self:GetParent().owner:ToggleScroll(self:GetChecked()) end)
	ToggleScroll:SetScript('OnShow', function(self) self:SetChecked(self:GetParent().owner.sets.disablescroll) end)
end

--[[ Menu Code ]]--
function Quest:CreateMenu()
	local menu = Dominos:NewMenu(self.id)
	AddLayoutPanel(menu)
	self.menu = menu
end



--[[ Override of the Default Tracker Width ]]--
--[[ Need to make this a secure hook! HOW???? ]]--



local oldSetWidth = WatchFrame.SetWidth
WatchFrame.SetWidth = function(self, width)
    oldSetWidth(self, width)

end






--[[
function WatchFrame_SetWidth(width)
	WATCHFRAME_EXPANDEDWIDTH = 204;
	WATCHFRAME_MAXLINEWIDTH = WATCHFRAME_EXPANDEDWIDTH;
		WatchFrame:SetWidth(WatchFrame:GetWidth());
		WatchFrame_Update();
end
--]]

